package cn.com.ty.lift.enterprise.organization.service;

import cn.com.ty.lift.common.constants.ApiConstants;
import cn.com.ty.lift.common.utils.ProjectUtils;
import cn.com.ty.lift.common.utils.TreeUtil;
import cn.com.ty.lift.enterprise.common.mapper.CommonMapper;
import cn.com.ty.lift.enterprise.organization.dao.entity.Organization;
import cn.com.ty.lift.enterprise.organization.dao.entity.Project;
import cn.com.ty.lift.enterprise.organization.dao.entity.model.OrganizationReq;
import cn.com.ty.lift.enterprise.organization.service.impl.ProjectServiceImpl;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.AllArgsConstructor;
import org.apache.commons.configuration.tree.TreeUtils;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
@AllArgsConstructor
public class OrganizationService {
    private final CommonMapper mapper;
    private final ProjectServiceImpl projectService;

    //获取维保公司下的1省，2市，3区，4项目和电梯数量 5项目成员列表
    public RestResponse datas(OrganizationReq organizationReq) {
        Map<String, Object> treeData = new HashMap<>();


        List<Map<String, Object>> provinces = new ArrayList<>();
        List<Map<String, Object>> cities = new ArrayList<>();
        List<Map<String, Object>> districts = new ArrayList<>();
        List<Map<String, Object>> projects = new ArrayList<>();
        List<Map<String, Object>> projectUsers = new ArrayList<>();
        switch (organizationReq.getListType()) {
            case 1:
                provinces = mapper.list("DISTINCT province,province_code provinceCode",
                        "project",
                        "where mt_company_id= " + organizationReq.getMtCompanyId());
                cities = mapper.list("DISTINCT city,city_code cityCode",
                        "project",
                        "where mt_company_id= " + organizationReq.getMtCompanyId());
                districts = mapper.list("DISTINCT district,district_code districtCode",
                        "project",
                        "where mt_company_id= " + organizationReq.getMtCompanyId());
                break;
            case 4:
                projects = mapper.list("DISTINCT id,project_name,num",
                        "project",
                        "where mt_company_id= " + organizationReq.getMtCompanyId());
                break;
            case 5:
                projectUsers = mapper.list(" pu.project_id,u.avatar_url,u.name,u.mobile,pu.is_monitor ",
                        " project_user pu left join user_info u on u.user_id = pu.user_id ",
                        "where mt_company_id = " + organizationReq.getMtCompanyId() + " and project_id = " + organizationReq.getProjectId());
                break;
        }


        List<String> provinceTemp = new ArrayList<>();
        List<String> cityTemp = new ArrayList<>();
        List<String> districtTemp = new ArrayList<>();
        List<String> p;
        List<String> pu;
        for (Map<String, Object> project : projects) {
            districtTemp.add(project.get("district").toString());

            for (String s : districtTemp) {
                if (!s.equals(project.get("district").toString())) {
//                    districts.add();
                }
            }
        }

        if (provinces.isEmpty()) {
            return RestResponse.ok(null, ApiConstants.RESULT_NO_DATA, "无数据");
        }
        HashMap<String, Object> allData = new HashMap<>();
        allData.put("provinces", provinces);
        allData.put("cities", cities);
        allData.put("districts", districts);
        return RestResponse.ok(allData, ApiConstants.RESULT_SUCCESS, "查询成功");
    }

    public RestResponse organizationList(OrganizationReq req) {
//        List<Map<String, Object>> projects = mapper.list("province, city, district,id, project_name, num",
//                "project",
//                "where mt_company_id=" + req.getMtCompanyId());
        List<Project> projects = projectService.list(new QueryWrapper<Project>()
                .select("id", "province", "city", "district", "project_name", "num")
                .eq("mt_company_id", req.getMtCompanyId()));
//        HashSet<Organization> provinces = new HashSet<>();
        Map<String, Organization> provinces = new HashMap<>();
//        HashSet<Organization> cities = new HashSet<>();
        Map<String, Organization> cities = new HashMap<>();
//        HashSet<Organization> districts = new HashSet<>();
        Map<String, Organization> districts = new HashMap<>();
        Organization province = new Organization();
        Organization city = new Organization();
        Organization district = new Organization();

        //遍历项目
        for (Project project : projects) {
            //获取省
            province.setAreaName(project.getProvince());
            province.setParentName(project.getProvince());
            //获取市
            city.setAreaName(project.getCity());
            city.setParentName(project.getProvince());
            //获取区
            district.setAreaName(project.getDistrict());
            district.setParentName(project.getCity());

            //新增区列表，区新增项目
            Organization organization = districts.get(project.getDistrict());
            if (organization != null) {
                //如果区列表不为空
                organization.getProjects().add(project);
            } else {
                //如果区列表为空
                organization = new Organization();
                organization.getProjects().add(project);
                districts.put(project.getDistrict(), organization);
            }

            //区列表放入市中
            city.setData(districts);

            //市放入市列表中
            city.setParentName(project.getProvince());
            cities.putIfAbsent(project.getCity(), city);
            //市列表放入省中
            province.setData(cities);

            //省放入省列表中
            provinces.putIfAbsent(project.getCity(), province);


            //遍历完一个项目，重新赋值变量
            province = new Organization();
            city = new Organization();
            district = new Organization();

        }
        //输出地区信息
        System.out.println(provinces);


        return RestResponse.ok(districts, ApiConstants.RESULT_SUCCESS, "查询成功");
    }
}
